scala.reflect

# ClassTag

###
Related Docs: object ClassTag | package reflect

#### trait ClassTag[T] extends ClassManifestDeprecatedApis[T] with Equals with Serializable

A `ClassTag[T]` stores the erased class of a given type `T`, accessible via the `runtimeClass` field. This is particularly useful for instantiating `Array`s whose element types are unknown at compile time.

`ClassTag`s are a weaker special case of scala.reflect.api.TypeTags#TypeTags, in that they wrap only the runtime class of a given type, whereas a `TypeTag` contains all static type information. That is, `ClassTag`s are constructed from knowing only the top-level class of a type, without necessarily knowing all of its argument types. This runtime information is enough for runtime `Array` creation.

For example:

    scala> def mkArray[T : ClassTag](elems: T*) = Array[T](elems: _*)
    mkArray: [T](elems: T*)(implicit evidence$1: scala.reflect.ClassTag[T])Array[T]

    scala> mkArray(42, 13)
    res0: Array[Int] = Array(42, 13)

    scala> mkArray("Japan","Brazil","Germany")
    res1: Array[String] = Array(Japan, Brazil, Germany)

See scala.reflect.api.TypeTags for more examples, or the Reflection Guide: TypeTags for more details.

Annotations
  @implicitNotFound( msg = "No ClassTag available for ${T}" )
Source
  ClassTag.scala

Linear Supertypes
Equals, ClassManifestDeprecatedApis[T], OptManifest[T], Serializable, java.io.Serializable, AnyRef, Any
Known Subclasses
AnyValManifest, Manifest
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ClassTag
2. Equals
3. ClassManifestDeprecatedApis
4. OptManifest
5. Serializable
6. Serializable
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def runtimeClass: Class[_]

   A class representing the type `U` to which `T` would be erased.

   A class representing the type `U` to which `T` would be erased. Note that there is no subtyping relationship between `T` and `U`.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ClassTag[T] to any2stringadd[ClassTag[T]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ClassTag[T], B)

   Implicit information
     This member is added by an implicit conversion from ClassTag[T] to ArrowAssoc[ClassTag[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def argString: String

   Attributes
     protected
   Definition Classes
     ClassManifestDeprecatedApis

7. #### def arrayClass[T](tp: Class[_]): Class[Array[T]]

   Attributes
     protected
   Definition Classes
     ClassManifestDeprecatedApis

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def canEqual(x: Any): Boolean

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

   returns

     true if this instance can possibly equal `that`, otherwise false

   Definition Classes
     ClassTag → Equals → ClassManifestDeprecatedApis

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def ensuring(cond: (ClassTag[T]) ⇒ Boolean, msg: ⇒ Any): ClassTag[T]

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to Ensuring[ClassTag[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (ClassTag[T]) ⇒ Boolean): ClassTag[T]

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to Ensuring[ClassTag[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): ClassTag[T]

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to Ensuring[ClassTag[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): ClassTag[T]

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to Ensuring[ClassTag[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(x: Any): Boolean

    The universal equality method defined in `AnyRef`.

    The universal equality method defined in `AnyRef`.

    Definition Classes
      ClassTag → Equals → AnyRef → Any

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to StringFormat[ClassTag[T]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      ClassTag → AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def newArray(len: Int): Array[T]

    Produces a new array with element type `T` and length `len`

    Produces a new array with element type `T` and length `len`

    Definition Classes
      ClassTag → ClassManifestDeprecatedApis

24. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      ClassTag → AnyRef → Any

28. #### def unapply(x: Unit): Option[T]

29. #### def unapply(x: Boolean): Option[T]

30. #### def unapply(x: Double): Option[T]

31. #### def unapply(x: Float): Option[T]

32. #### def unapply(x: Long): Option[T]

33. #### def unapply(x: Int): Option[T]

34. #### def unapply(x: Char): Option[T]

35. #### def unapply(x: Short): Option[T]

36. #### def unapply(x: Byte): Option[T]

37. #### def unapply(x: Any): Option[T]

    A ClassTag[T] can serve as an extractor that matches only objects of type T.

    A ClassTag[T] can serve as an extractor that matches only objects of type T.

    The compiler tries to turn unchecked type tests in pattern matches into checked ones by wrapping a `(_: T)` type pattern as `ct(_: T)`, where `ct` is the `ClassTag[T]` instance. Type tests necessary before calling other extractors are treated similarly. `SomeExtractor(...)` is turned into `ct(SomeExtractor(...))` if `T` in `SomeExtractor.unapply(x: T)` is uncheckable, but we have an instance of `ClassTag[T]`.

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### def wrap: ClassTag[Array[T]]

    Produces a `ClassTag` that knows how to instantiate an `Array[Array[T]]`

42. #### def →[B](y: B): (ClassTag[T], B)

    Implicit information
      This member is added by an implicit conversion from ClassTag[T] to ArrowAssoc[ClassTag[T]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def <:<(that: ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a subtype of the type represented by `that` manifest, subject to the limitations described in the header.

   Tests whether the type represented by this manifest is a subtype of the type represented by `that` manifest, subject to the limitations described in the header.

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use scala.reflect.runtime.universe.TypeTag for subtype checking instead

2. #### def >:>(that: ClassManifest[_]): Boolean

   Tests whether the type represented by this manifest is a supertype of the type represented by `that` manifest, subject to the limitations described in the header.

   Tests whether the type represented by this manifest is a supertype of the type represented by `that` manifest, subject to the limitations described in the header.

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use scala.reflect.runtime.universe.TypeTag for subtype checking instead

3. #### def arrayManifest: ClassManifest[Array[T]]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use wrap instead

4. #### def erasure: Class[_]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use runtimeClass instead

5. #### def newArray2(len: Int): Array[Array[T]]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use wrap.newArray instead

6. #### def newArray3(len: Int): Array[Array[Array[T]]]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use wrap.wrap.newArray instead

7. #### def newArray4(len: Int): Array[Array[Array[Array[T]]]]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use wrap.wrap.wrap.newArray instead

8. #### def newArray5(len: Int): Array[Array[Array[Array[Array[T]]]]]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use wrap.wrap.wrap.wrap.newArray instead

9. #### def newArrayBuilder(): ArrayBuilder[T]

   Definition Classes
     ClassManifestDeprecatedApis
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use ArrayBuilder.make(this) instead

10. #### def newWrappedArray(len: Int): WrappedArray[T]

    Definition Classes
      ClassManifestDeprecatedApis
    Annotations
      @deprecated
    Deprecated

      (Since version 2.10.0) Create WrappedArray directly instead

11. #### def typeArguments: List[OptManifest[_]]

    Definition Classes
      ClassManifestDeprecatedApis
    Annotations
      @deprecated
    Deprecated

      (Since version 2.10.0) Use scala.reflect.runtime.universe.TypeTag to capture type structure instead

### Inherited from Equals

### Inherited from ClassManifestDeprecatedApis[T]

### Inherited from OptManifest[T]

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ClassTag[T] to any2stringadd[ClassTag[T]]

### Inherited by implicit conversion StringFormat from ClassTag[T] to StringFormat[ClassTag[T]]

### Inherited by implicit conversion Ensuring from ClassTag[T] to Ensuring[ClassTag[T]]

### Inherited by implicit conversion ArrowAssoc from ClassTag[T] to ArrowAssoc[ClassTag[T]]

### Ungrouped